%?mingw_package_header

%global qt_module qt3d
#%%global pre beta1

#%%global snapshot_date 20140525
#%%global snapshot_rev bdb98ba

%if 0%{?snapshot_date}
%global source_folder qt-%{qt_module}
%else
%global source_folder %{qt_module}-opensource-src-%{version}%{?pre:-%{pre}}
%endif

# first two digits of version
%global release_version %(echo %{version} | awk -F. '{print $1"."$2}')

Name:           mingw-qt5-%{qt_module}
Version:        5.5.0
Release:        1%{?pre:.%{pre}}%{?snapshot_date:.git%{snapshot_date}.%{snapshot_rev}}%{?dist}
Summary:        Qt5 for Windows - Qt3d component

License:        GPLv3 with exceptions or LGPLv2 with exceptions
Group:          Development/Libraries
URL:            http://qt.io/

%if 0%{?snapshot_date}
# To regenerate:
# wget http://qt.gitorious.org/qt/%{qt_module}/archive-tarball/%{snapshot_rev} -O qt5-%{qt_module}-%{snapshot_rev}.tar.gz
Source0:        qt5-%{qt_module}-%{snapshot_rev}.tar.gz
%else
%if "%{?pre}" != ""
Source0:        http://download.qt-project.org/development_releases/qt/%{release_version}/%{version}-%{pre}/submodules/%{qt_module}-opensource-src-%{version}-%{pre}.tar.xz
%else
Source0:        http://download.qt-project.org/official_releases/qt/%{release_version}/%{version}/submodules/%{qt_module}-opensource-src-%{version}.tar.xz
%endif
%endif

BuildArch:      noarch

BuildRequires:  mingw32-filesystem >= 96
BuildRequires:  mingw32-qt5-qtbase >= 5.5.0
BuildRequires:  mingw32-qt5-qtdeclarative >= 5.5.0
BuildRequires:  mingw32-qt5-qtquick1 >= 5.5.0

BuildRequires:  mingw64-filesystem >= 96
BuildRequires:  mingw64-qt5-qtbase >= 5.5.0
BuildRequires:  mingw64-qt5-qtdeclarative >= 5.5.0
BuildRequires:  mingw64-qt5-qtquick1 >= 5.5.0

# This package depends on QtOpenGLExtensions which is only available as a static library
# See http://code.qt.io/cgit/qt/qtbase.git/commit/?id=a2ddf3dfe066bb4e58de1d11b1800efcd05fb3a0
BuildRequires:  mingw32-qt5-qtbase-static
BuildRequires:  mingw64-qt5-qtbase-static


%description
This package contains the Qt software toolkit for developing
cross-platform applications.

This is the Windows version of Qt, for use in conjunction with the
Fedora Windows cross-compiler.


# Win32
%package -n mingw32-qt5-%{qt_module}
Summary:        Qt5 for Windows - Qt3d component

%description -n mingw32-qt5-%{qt_module}
This package contains the Qt software toolkit for developing
cross-platform applications.

This is the Windows version of Qt, for use in conjunction with the
Fedora Windows cross-compiler.


# Win64
%package -n mingw64-qt5-%{qt_module}
Summary:        Qt5 for Windows - Qt3d component

%description -n mingw64-qt5-%{qt_module}
This package contains the Qt software toolkit for developing
cross-platform applications.

This is the Windows version of Qt, for use in conjunction with the
Fedora Windows cross-compiler.


%?mingw_debug_package


%prep
%setup -q -n %{source_folder}

%if 0%{?snapshot_date}
# Make sure the syncqt tool is run because we're using a git snapshot
# Otherwise the build fails against Qt 5.1
mkdir .git
%endif


%build
%mingw_qmake_qt5 ../%{qt_module}.pro
%mingw_make %{?_smp_mflags}


%install
%mingw_make install INSTALL_ROOT=$RPM_BUILD_ROOT

# .prl files aren't interesting for us
find $RPM_BUILD_ROOT -name "*.prl" -delete


# Win32
%files -n mingw32-qt5-%{qt_module}
%doc LICENSE.GPL LICENSE.LGPLv3
%{mingw32_bindir}/Qt53DCore.dll
%{mingw32_bindir}/Qt53DInput.dll
%{mingw32_bindir}/Qt53DQuick.dll
%{mingw32_bindir}/Qt53DQuickRenderer.dll
%{mingw32_bindir}/Qt53DRenderer.dll
%{mingw32_includedir}/qt5/Qt3DCore/
%{mingw32_includedir}/qt5/Qt3DInput/
%{mingw32_includedir}/qt5/Qt3DQuick/
%{mingw32_includedir}/qt5/Qt3DQuickRenderer/
%{mingw32_includedir}/qt5/Qt3DRenderer/
%{mingw32_libdir}/libQt53DCore.dll.a
%{mingw32_libdir}/libQt53DInput.dll.a
%{mingw32_libdir}/libQt53DQuick.dll.a
%{mingw32_libdir}/libQt53DQuickRenderer.dll.a
%{mingw32_libdir}/libQt53DRenderer.dll.a
%{mingw32_libdir}/cmake/Qt53DCore/
%{mingw32_libdir}/cmake/Qt53DInput/
%{mingw32_libdir}/cmake/Qt53DQuick/
%{mingw32_libdir}/cmake/Qt53DQuickRenderer/
%{mingw32_libdir}/cmake/Qt53DRenderer/
%{mingw32_libdir}/pkgconfig/Qt53DCore.pc
%{mingw32_libdir}/pkgconfig/Qt53DInput.pc
%{mingw32_libdir}/pkgconfig/Qt53DQuick.pc
%{mingw32_libdir}/pkgconfig/Qt53DQuickRenderer.pc
%{mingw32_libdir}/pkgconfig/Qt53DRenderer.pc
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_3dcore.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_3dcore_private.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_3dinput.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_3dinput_private.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_3dquick.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_3dquick_private.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_3dquickrenderer.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_3dquickrenderer_private.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_3drenderer.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_3drenderer_private.pri
%dir %{mingw32_datadir}/qt5/qml/Qt3D/
%{mingw32_datadir}/qt5/qml/Qt3D/qmldir
%{mingw32_datadir}/qt5/qml/Qt3D/quick3dcoreplugin.dll
%dir %{mingw32_datadir}/qt5/qml/Qt3D/Input/
%{mingw32_datadir}/qt5/qml/Qt3D/Input/qmldir
%{mingw32_datadir}/qt5/qml/Qt3D/Input/quick3dinputplugin.dll
%dir %{mingw32_datadir}/qt5/qml/Qt3D/Renderer/
%{mingw32_datadir}/qt5/qml/Qt3D/Renderer/qmldir
%{mingw32_datadir}/qt5/qml/Qt3D/Renderer/quick3drendererplugin.dll
%dir %{mingw32_datadir}/qt5/qml/QtQuick/Scene3D/
%{mingw32_datadir}/qt5/qml/QtQuick/Scene3D/qmldir
%{mingw32_datadir}/qt5/qml/QtQuick/Scene3D/qtquickscene3dplugin.dll

# Win64
%files -n mingw64-qt5-%{qt_module}
%doc LICENSE.GPL LICENSE.LGPLv3
%{mingw64_bindir}/Qt53DCore.dll
%{mingw64_bindir}/Qt53DInput.dll
%{mingw64_bindir}/Qt53DQuick.dll
%{mingw64_bindir}/Qt53DQuickRenderer.dll
%{mingw64_bindir}/Qt53DRenderer.dll
%{mingw64_includedir}/qt5/Qt3DCore/
%{mingw64_includedir}/qt5/Qt3DInput/
%{mingw64_includedir}/qt5/Qt3DQuick/
%{mingw64_includedir}/qt5/Qt3DQuickRenderer/
%{mingw64_includedir}/qt5/Qt3DRenderer/
%{mingw64_libdir}/libQt53DCore.dll.a
%{mingw64_libdir}/libQt53DInput.dll.a
%{mingw64_libdir}/libQt53DQuick.dll.a
%{mingw64_libdir}/libQt53DQuickRenderer.dll.a
%{mingw64_libdir}/libQt53DRenderer.dll.a
%{mingw64_libdir}/cmake/Qt53DCore/
%{mingw64_libdir}/cmake/Qt53DInput/
%{mingw64_libdir}/cmake/Qt53DQuick/
%{mingw64_libdir}/cmake/Qt53DQuickRenderer/
%{mingw64_libdir}/cmake/Qt53DRenderer/
%{mingw64_libdir}/pkgconfig/Qt53DCore.pc
%{mingw64_libdir}/pkgconfig/Qt53DInput.pc
%{mingw64_libdir}/pkgconfig/Qt53DQuick.pc
%{mingw64_libdir}/pkgconfig/Qt53DQuickRenderer.pc
%{mingw64_libdir}/pkgconfig/Qt53DRenderer.pc
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_3dcore.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_3dcore_private.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_3dinput.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_3dinput_private.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_3dquick.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_3dquick_private.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_3dquickrenderer.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_3dquickrenderer_private.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_3drenderer.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_3drenderer_private.pri
%dir %{mingw64_datadir}/qt5/qml/Qt3D/
%{mingw64_datadir}/qt5/qml/Qt3D/qmldir
%{mingw64_datadir}/qt5/qml/Qt3D/quick3dcoreplugin.dll
%dir %{mingw64_datadir}/qt5/qml/Qt3D/Input/
%{mingw64_datadir}/qt5/qml/Qt3D/Input/qmldir
%{mingw64_datadir}/qt5/qml/Qt3D/Input/quick3dinputplugin.dll
%dir %{mingw64_datadir}/qt5/qml/Qt3D/Renderer/
%{mingw64_datadir}/qt5/qml/Qt3D/Renderer/qmldir
%{mingw64_datadir}/qt5/qml/Qt3D/Renderer/quick3drendererplugin.dll
%dir %{mingw64_datadir}/qt5/qml/QtQuick/Scene3D/
%{mingw64_datadir}/qt5/qml/QtQuick/Scene3D/qmldir
%{mingw64_datadir}/qt5/qml/QtQuick/Scene3D/qtquickscene3dplugin.dll


%changelog
* Fri Aug  7 2015 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.5.0-1
- Update to 5.5.0
- Added BR: mingw{32,64}-qt5-qtbase-static as this package depends
  on QtOpenGLExtensions which is only available as a static library

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.0.0-0.13.git20140525.bdb98ba
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.0.0-0.12.git20140525.bdb98ba
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun May 25 2014 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.11.git20140525.bdb98ba
- Update to 20140525 snapshot (rev bdb98ba)

* Sun Jan 12 2014 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.10.git20130923.7433868
- Don't carry .dll.debug files in main package

* Wed Jan  8 2014 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.9.git20130923.7433868
- Dropped manual rename of import libraries

* Sun Jan  5 2014 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.8.git20130923.7433868
- Update to 20130923 snapshot (rev 7433868)
  This is the last Qt 5.2 based revision

* Sun Dec 01 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.7.git20130510.0158ce78
- Fix FTBFS against Qt 5.2

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.0.0-0.6.git20130510.0158ce78
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Jul 18 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.5.git20130510.0158ce78
- Make sure the syncqt tool is run because we're using a git snapshot

* Fri May 10 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.4.git20130510.0158ce78
- Update to 20130510 snapshot (rev 0158ce78)

* Sat Jan 12 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.3.git20121111.e4d3ccac
- Fix filelist

* Sun Nov 11 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.2.beta1.git20121111.e4d3ccac
- Update to 20121111 snapshot (rev e4d3ccac)
- Rebuild against latest mingw-qt5-qtbase
- Dropped pkg-config rename hack as it's unneeded now

* Wed Sep 12 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.1.beta1
- Initial release

